package org.zheng.demo.assertJsonCollection;

import static org.junit.jupiter.api.Assertions.assertEquals;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.junit.jupiter.api.Test;
import org.skyscreamer.jsonassert.JSONAssert;

public class TestAssertJsonCollectionWithJsonAssert extends TestJsonData {

	private List<JSONObject> jsonArrayToSortedList(final JSONArray jsonArray) throws JSONException {
		List<JSONObject> sortedList = new ArrayList<>();

		for (int i = 0; i < jsonArray.length(); i++) {
			sortedList.add(jsonArray.getJSONObject(i));
		}

		sortedList.sort(Comparator.comparingInt(o -> {
			try {
				return o.getInt("id");
			} catch (JSONException e) {
				e.printStackTrace();
			}
			return 0;
		}));

		return sortedList;
	}

	@Test
	void test_jsonassert_JSONObject() throws Exception {
		JSONArray actualArray = new JSONArray(actualJsonArray);
		JSONArray expectedArray = new JSONArray(expectedJsonArray);

		List<JSONObject> actualSortedList = jsonArrayToSortedList(actualArray);
		List<JSONObject> expectedSortedList = jsonArrayToSortedList(expectedArray);

		assertEquals(actualSortedList.size(), expectedSortedList.size());

		for (int i = 0; i < expectedSortedList.size(); i++) {
			JSONAssert.assertEquals(expectedSortedList.get(i).toString(), actualSortedList.get(i).toString(), true);
		}
	}

}
